Index: main/trunk/greenstone2/Install.txt
===================================================================
--- main/trunk/greenstone2/Install.txt	(revision 22766)
+++ main/trunk/greenstone2/Install.txt	(revision 26971)
@@ -4,10 +4,10 @@
 The following instructions assume the top level Greenstone folder is called
 Greenstone (which is the standard name used for Greenstone 2 releases). 
-If you have got Greenstone from SVN, the top level directory will be gsdl. 
+If you have got Greenstone from SVN, the top level directory will be greenstone2. 
 
 The Greenstone Librarian Interface (GLI) code will be in the gli folder inside
 the Greenstone folder. If you are using SVN and you want to use the GLI to 
 build collections, you'll need to check it out by running
- svn checkout http://svn.greenstone.org/gli/trunk gli
+ svn checkout http://svn.greenstone.org/main/trunk/gli
 in the Greenstone folder.
 
@@ -17,13 +17,13 @@
 where this file lives) and perform the following three steps.
 
-1. ./configure
+1. ./configure --enable-apache-httpd
 2. make
 3. make install
 
 This will install the library.cgi and oaiserver.cgi executables to 
-Greenstone/cgi-bin. 
+Greenstone/cgi-bin/linux. 
 If you want to run Greenstone from a system 
 cgi-bin directory you'll need to move the library executable and 
-gsdlsite.cfg from Greenstone/cgi-bin to your system cgi-bin.
+gsdlsite.cfg from Greenstone/cgi-bin/linux to your system cgi-bin.
 
 Note that the Greenstone directory structure is important to the operation
@@ -33,5 +33,7 @@
 entire Greenstone directory there.
 
-You'll need to install Apache and set it up to serve Greenstone. Then you'll need to edit Greenstone/cgi-bin/gsdlsite.cfg. See 
+Greenstone will install Apache into apache-httpd/linux. You can disable this 
+by running ./configure without the -enable-apache-httpd option. In that case 
+you'll need to set up your own apache to serve Greenstone. See   See 
 http://wiki.greenstone.org/wiki/index.php/Setting_up_an_Apache_Web_Server_for_Greenstone_2_Walkthrough
 for more details.  
@@ -46,38 +48,21 @@
 it at greenstone-devel@list.scms.waikato.ac.nz
 
-The major difference between compiling with VC++ 4.2 compared with 
-VC++ 6.0/2005 is that 4.2 must use the STLport standard template library 
-(packaged with Greenstone) while VC++ 6.0/2005 may use its own built in 
-STL implementation.
+If you have got Greenstone from svn, you'll also need to download some Windows binaries.
+1. cd to top-level greenstone2 folder.
+2. cd bin
+3. svn co http://svn.greenstone.org/main/trunk/binaries/windows/bin windows
 
-Perform the following steps to compile and install Greenstone. Note that
-some parts of the process described are specific to one or other of the two
-compilation options mentioned above. These steps are marked as such.
+There is a batch script you can run to set up and compile Greenstone.
+For 64 bit machines, run 
+   * makegs264.bat
+For 32 bit machines, run
+   * makegs2.bat
 
-1. Unzip the following zip archives (into the directories in which the
-   zip files themselves are contained).
+For more information about compiling Greenstone, or for manual compling instructions, see
+http://wiki.greenstone.org/wiki/index.php/Compiling_Greenstone
 
-   * Greenstone\common-src\indexers\packages\windows\iconv\iconv.zip
-   * Greenstone\common-src\packages\windows\gdbm\gdbm.zip
-   * Greenstone\common-src\packages\windows\crypt\crypt.zip
-   * Greenstone\common-src\packages\windows\stlport\stlport.zip (VC++ 4.2 only)
+These scripts will unpack necessary zip files, set up paths etc, then compile Greenstone.
 
-2. To use VC++ command line tools you may need to execute the
-   MSDEV\BIN\VCVARS32.BAT batch file to set up your environment.
-
-3. cd to the top level Greenstone directory (i.e. the directory where 
-   this file lives).
-
-4. compile the web library (library.cgi) and OAI server (oaiserver.cgi) with
-   "nmake /f win32.mak GSDL_VC4=1" (VC++ 4.2)
-   or
-   "nmake /f win32.mak" (VC++ 6.0/2005)
-
-5. compile the local library (server.exe) with
-   "nmake /f win32.mak GSDL_VC4=1 LOCAL_LIBRARY=1" (VC++ 4.2)
-   or
-   "nmake /f win32.mak LOCAL_LIBRARY=1" (VC++ 6.0/2005)
-
-This will install library.cgi and oaiserver.cgi to the Greenstone\cgi-bin 
+This will install library.cgi and oaiserver.cgi to the Greenstone\cgi-bin\windows 
 directory and server.exe to the top level Greenstone directory. 
 