Index: /main/trunk/greenstone2/collect/demo/etc/collect.cfg
===================================================================
--- /main/trunk/greenstone2/collect/demo/etc/collect.cfg	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/etc/collect.cfg	(revision 27030)
@@ -7,5 +7,5 @@
 infodbtype	gdbm
 
-indexes		text dls.Title,ex.Title dls.Subject dls.Organization dls.Keyword
+indexes		text dc.Title,ex.Title dc.Subject dls.Organization dls.Keyword
 
 levels	section document
@@ -15,15 +15,15 @@
 # following two plugins not needed for the demo collection, but are useful to
 # include for tutorial purposes
-plugin  ImagePlugin
-plugin  ZIPPlugin
+plugin	ImagePlugin
+plugin	ZIPPlugin
 plugin	MetadataXMLPlugin
 plugin	ArchivesInfPlugin
 plugin	DirectoryPlugin
 
-classify	List -metadata dls.Title -partition_type_within_level constant_size
+classify	List -metadata dc.Title -partition_type_within_level constant_size
 
-classify	Hierarchy -metadata dls.Subject -sort dls.Title
+classify	Hierarchy -metadata dc.Subject -sort dc.Title
 
-classify	List -sort_leaf_nodes_using dls.Title -metadata dls.Organization -bookshelf_type always -partition_type_within_level constant_size
+classify	List -sort_leaf_nodes_using dc.Title -metadata dls.Organization -bookshelf_type always -partition_type_within_level constant_size
 
 classify	List -metadata dls.Keyword -partition_type_within_level constant_size -buttonname Howto
@@ -50,6 +50,6 @@
 # default
 collectionmeta	.text [l=en] "_labeltext_"
-collectionmeta	.dls.Title,Title [l=en] "_labelTitle_"
-collectionmeta	.dls.Subject [l=en] "_labelSubject_"
+collectionmeta	.dc.Title,Title [l=en] "_labelTitle_"
+collectionmeta	.dc.Subject [l=en] "_labelSubject_"
 collectionmeta	.dls.Organization [l=en] "_labelOrganization_"
 collectionmeta	.dls.Keyword [l=en] "_labelHowto_"
@@ -62,5 +62,5 @@
 collectionmeta	collectionextra [l=en] "This is a demonstration collection for the Greenstone digital library software.\nIt contains a small subset (11 documents) of the Humanity Development Library."
 
-collectionmeta	depositormetadata [l=en] "{\"name\":\"dls.Title\",\"label\":\"Title\",\"tooltip\":\"dls.Title: The title of this resource.\",\"type\":\"text\"}, {\"name\":\"dls.Organization\",\"label\":\"Organization\",\"tooltip\":\"dls.Organization: The organization responsible for producing this resource.\",\"type\":\"text\"}, {\"name\":\"dls.Subject\",\"label\":\"Subject\",\"tooltip\":\"dls.Subject: The subject of this resource.\",\"type\":\"text\"}, {\"name\":\"dls.Keyword\",\"label\":\"Keyword\",\"tooltip\":\"dls.Keyword: A more specific indication of what the resource can be used for.\",\"type\":\"text\"}, {\"name\":\"dls.Language\",\"label\":\"Language\",\"tooltip\":\"dls.Language: The language of this resource.\",\"type\":\"text\"}"
+collectionmeta	depositormetadata [l=en] "{\"name\":\"dc.Title\",\"label\":\"Title\",\"tooltip\":\"dc.Title: The title of this resource.\",\"type\":\"text\"}, {\"name\":\"dls.Organization\",\"label\":\"Organization\",\"tooltip\":\"dls.Organization: The organization responsible for producing this resource.\",\"type\":\"text\"}, {\"name\":\"dc.Subject\",\"label\":\"Subject\",\"tooltip\":\"dc.Subject: The subject of this resource.\",\"type\":\"text\"}, {\"name\":\"dls.Keyword\",\"label\":\"Keyword\",\"tooltip\":\"dls.Keyword: A more specific indication of what the resource can be used for.\",\"type\":\"text\"}, {\"name\":\"dc.Language\",\"label\":\"Language\",\"tooltip\":\"dc.Language: The language of this resource.\",\"type\":\"text\"}"
 
 # -- French strings ----------------
Index: /main/trunk/greenstone2/collect/demo/import/b17mie/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/b17mie/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/b17mie/metadata.xml	(revision 27030)
@@ -5,7 +5,7 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">Microlivestock - Little-Known Small Animals with a Promising Economic Future (b17mie)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
+            <Metadata name="dc.Title">Microlivestock - Little-Known Small Animals with a Promising Economic Future (b17mie)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">BOSTID</Metadata>
             <Metadata mode="accumulate" name="dls.Keyword">introduce small animals and micro-livestock in your farm</Metadata>
Index: /main/trunk/greenstone2/collect/demo/import/b18ase/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/b18ase/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/b18ase/metadata.xml	(revision 27030)
@@ -5,7 +5,7 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">Little Known Asian Animals With a Promising Economic Future (b18ase)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
+            <Metadata name="dc.Title">Little Known Asian Animals With a Promising Economic Future (b18ase)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">BOSTID</Metadata>
             <Metadata mode="accumulate" name="dls.Keyword">introduce little-known Asian farm animals with a promising future</Metadata>
Index: /main/trunk/greenstone2/collect/demo/import/b20cre/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/b20cre/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/b20cre/metadata.xml	(revision 27030)
@@ -5,7 +5,7 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">Managing Tropical Animal Resources - Crocodiles as a Resource for the Tropics (b20cre)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
+            <Metadata name="dc.Title">Managing Tropical Animal Resources - Crocodiles as a Resource for the Tropics (b20cre)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">BOSTID</Metadata>
         </Description>
Index: /main/trunk/greenstone2/collect/demo/import/b21wae/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/b21wae/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/b21wae/metadata.xml	(revision 27030)
@@ -5,8 +5,8 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">The Water Buffalo: New Prospects For An Underutilized Animal (1984) (b21wae)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Animal Husbandry and Animal Product Processing|Cattle</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
+            <Metadata name="dc.Title">The Water Buffalo: New Prospects For An Underutilized Animal (1984) (b21wae)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Animal Husbandry and Animal Product Processing|Cattle</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">BOSTID</Metadata>
             <Metadata mode="accumulate" name="dls.Keyword">utilize the Water Buffalo more effectively</Metadata>
Index: /main/trunk/greenstone2/collect/demo/import/b22bue/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/b22bue/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/b22bue/metadata.xml	(revision 27030)
@@ -5,7 +5,7 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">Butterfly Farming in Papua New Guinea (b22bue)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
+            <Metadata name="dc.Title">Butterfly Farming in Papua New Guinea (b22bue)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Animal Husbandry and Animal Product Processing|Other animals (micro-livestock, little known animals, silkworms, reptiles, frogs, snails, game, etc.)</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">BOSTID</Metadata>
             <Metadata mode="accumulate" name="dls.Keyword">start a butterfly farm</Metadata>
Index: /main/trunk/greenstone2/collect/demo/import/ec158e/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/ec158e/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/ec158e/metadata.xml	(revision 27030)
@@ -5,8 +5,8 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">The Courier - NÂ°158 - July - August 1996 Dossier Communication and the media - Country report Cape Verde (ec158e)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Communication, Information and Documentation|Communication, telecommunication, mass communication, mass media, film-making</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Development Periodicals and Magazines|The Courier ACP 1990 - 1996 Africa-Caribbean-Pacific - European Union</Metadata>
+            <Metadata name="dc.Title">The Courier - NÂ°158 - July - August 1996 Dossier Communication and the media - Country report Cape Verde (ec158e)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Communication, Information and Documentation|Communication, telecommunication, mass communication, mass media, film-making</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Development Periodicals and Magazines|The Courier ACP 1990 - 1996 Africa-Caribbean-Pacific - European Union</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">EC Courier</Metadata>
         </Description>
Index: /main/trunk/greenstone2/collect/demo/import/ec159e/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/ec159e/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/ec159e/metadata.xml	(revision 27030)
@@ -5,8 +5,8 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">The Courier - NÂ°159 - Sept- Oct 1996 Dossier Investing in People Country Reports: Mali ; Western Samoa (ec159e)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Society, Culture, Community, Woman, Youth, Population|Social sciences, sociology (works comprising several subgroups) incl. participatory research and training</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Development Periodicals and Magazines|The Courier ACP 1990 - 1996 Africa-Caribbean-Pacific - European Union</Metadata>
+            <Metadata name="dc.Title">The Courier - NÂ°159 - Sept- Oct 1996 Dossier Investing in People Country Reports: Mali ; Western Samoa (ec159e)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Society, Culture, Community, Woman, Youth, Population|Social sciences, sociology (works comprising several subgroups) incl. participatory research and training</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Development Periodicals and Magazines|The Courier ACP 1990 - 1996 Africa-Caribbean-Pacific - European Union</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">EC Courier</Metadata>
         </Description>
Index: /main/trunk/greenstone2/collect/demo/import/ec160e/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/ec160e/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/ec160e/metadata.xml	(revision 27030)
@@ -5,8 +5,8 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">The Courier - NÂ°160 - Nov - Dec 1996 - Dossier Habitat - Country reports: Fiji , Tonga (ec160e)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Settlements, Housing, Building - Infrastructure Construction (Roads etc)|Settlements and housing: general works incl. low- cost housing, planning techniques, surveying, etc.</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Development Periodicals and Magazines|The Courier ACP 1990 - 1996 Africa-Caribbean-Pacific - European Union</Metadata>
+            <Metadata name="dc.Title">The Courier - NÂ°160 - Nov - Dec 1996 - Dossier Habitat - Country reports: Fiji , Tonga (ec160e)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Settlements, Housing, Building - Infrastructure Construction (Roads etc)|Settlements and housing: general works incl. low- cost housing, planning techniques, surveying, etc.</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Development Periodicals and Magazines|The Courier ACP 1990 - 1996 Africa-Caribbean-Pacific - European Union</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">EC Courier</Metadata>
         </Description>
Index: /main/trunk/greenstone2/collect/demo/import/fb33fe/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/fb33fe/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/fb33fe/metadata.xml	(revision 27030)
@@ -5,8 +5,8 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">Farming snails 1: Learning about snails; Building a pen; Food and shelter plants (fb33fe)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Agriculture and Food Processing|Better Farming series of FAO and INADES - 46 booklets</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Settlements, Housing, Building - Infrastructure Construction (Roads etc)|Settlements and housing: general works incl. low- cost housing, planning techniques, surveying, etc.</Metadata>
+            <Metadata name="dc.Title">Farming snails 1: Learning about snails; Building a pen; Food and shelter plants (fb33fe)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Agriculture and Food Processing|Better Farming series of FAO and INADES - 46 booklets</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Settlements, Housing, Building - Infrastructure Construction (Roads etc)|Settlements and housing: general works incl. low- cost housing, planning techniques, surveying, etc.</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">FAO Better Farming series</Metadata>
          </Description>
Index: /main/trunk/greenstone2/collect/demo/import/fb34fe/metadata.xml
===================================================================
--- /main/trunk/greenstone2/collect/demo/import/fb34fe/metadata.xml	(revision 27029)
+++ /main/trunk/greenstone2/collect/demo/import/fb34fe/metadata.xml	(revision 27030)
@@ -5,8 +5,8 @@
         <FileName>.*</FileName>
         <Description>
-            <Metadata name="dls.Title">Farming snails 2: Choosing snails; Care and harvesting; Further improvement (fb34fe)</Metadata>
-            <Metadata mode="accumulate" name="dls.Language">English</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Agriculture and Food Processing|Better Farming series of FAO and INADES - 46 booklets</Metadata>
-            <Metadata mode="accumulate" name="dls.Subject">Settlements, Housing, Building - Infrastructure Construction (Roads etc)|Settlements and housing: general works incl. low- cost housing, planning techniques, surveying, etc.</Metadata>
+            <Metadata name="dc.Title">Farming snails 2: Choosing snails; Care and harvesting; Further improvement (fb34fe)</Metadata>
+            <Metadata mode="accumulate" name="dc.Language">English</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Agriculture and Food Processing|Better Farming series of FAO and INADES - 46 booklets</Metadata>
+            <Metadata mode="accumulate" name="dc.Subject">Settlements, Housing, Building - Infrastructure Construction (Roads etc)|Settlements and housing: general works incl. low- cost housing, planning techniques, surveying, etc.</Metadata>
             <Metadata mode="accumulate" name="dls.Organization">FAO Better Farming series</Metadata>
             <Metadata mode="accumulate" name="dls.Keyword">farm snails</Metadata>